# -*- coding: utf-8 -*-
#
# File: SmartPortlet.py
#
# Copyright (c) 2006 by Sean Fulmer
# Generator: ArchGenXML Version 1.5.0 svn/devel
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Sean Fulmer <smartportlets@noandwhere.com>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.SmartPortlets.config import *

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    ReferenceField(
        name='smartFolder',
        widget=ReferenceWidget(
            label="Smart Folder",
            label_msgid='SmartPortlets_label_smartFolder',
            i18n_domain='SmartPortlets',
        ),
        allowed_types="Topic",
        relationship="FolderForPortlet",
        required=1,
    ),

    IntegerField(
        name='maxItems',
        default="0",
        widget=IntegerWidget(
            label="Maximum number of items to display",
            label_msgid='SmartPortlets_label_maxItems',
            i18n_domain='SmartPortlets',
        ),
        required=1,
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

SmartPortlet_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class SmartPortlet(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'SmartPortlet'

    meta_type = 'SmartPortlet'
    portal_type = 'SmartPortlet'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'SmartPortlet.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "SmartPortlet"
    typeDescMsgId = 'description_edit_smartportlet'

    _at_rename_after_creation = True

    schema = SmartPortlet_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getSource')
    def getSource(self):
        """returns the smart folder for this portlet
        """
        refs = self.getRefs(relationship='FolderForPortlet')
        
        if not refs:
            raise 'Missing reference on SmartPortlet with id %s' % self.id

        return refs[0]


registerType(SmartPortlet, PROJECTNAME)
# end of class SmartPortlet

##code-section module-footer #fill in your manual code here
##/code-section module-footer



